## rustc 1.10.0+dfsg1

=== src/compiler-rt/lib/builtins/CMakeLists.txt ===
# This directory contains a large amount of C code which provides
# generic implementations of the core runtime library along with optimized
# architecture-specific code in various subdirectories.

set(GENERIC_SOURCES
  absvdi2.c
  absvsi2.c
  absvti2.c
  adddf3.c
  addsf3.c
  addtf3.c
  addvdi3.c
  addvsi3.c
  addvti3.c
  apple_versioning.c
  ashldi3.c
  ashlti3.c
  ashrdi3.c
  ashrti3.c
  # FIXME: atomic.c may only be compiled if host compiler understands _Atomic
  # atomic.c
  clear_cache.c
  clzdi2.c
  clzsi2.c
  clzti2.c
  cmpdi2.c
  cmpti2.c
  comparedf2.c
  comparesf2.c
  ctzdi2.c
  ctzsi2.c
  ctzti2.c
  divdc3.c
  divdf3.c
  divdi3.c
  divmoddi4.c
  divmodsi4.c
  divsc3.c
  divsf3.c
  divsi3.c
  divti3.c
  divtf3.c
  divxc3.c
  enable_execute_stack.c
  eprintf.c
  extendsfdf2.c
  extendhfsf2.c
  ffsdi2.c
  ffsti2.c
  fixdfdi.c
  fixdfsi.c
  fixdfti.c
  fixsfdi.c
  fixsfsi.c
  fixsfti.c
  fixunsdfdi.c
  fixunsdfsi.c
  fixunsdfti.c
  fixunssfdi.c
  fixunssfsi.c
  fixunssfti.c
  fixunsxfdi.c
  fixunsxfsi.c
  fixunsxfti.c
  fixxfdi.c
  fixxfti.c
  floatdidf.c
  floatdisf.c
  floatdixf.c
  floatsidf.c
  floatsisf.c
  floattidf.c
  floattisf.c
  floattixf.c
  floatundidf.c
  floatundisf.c
  floatundixf.c
  floatunsidf.c
  floatunsisf.c
  floatuntidf.c
  floatuntisf.c
  floatuntixf.c
  int_util.c
  lshrdi3.c
  lshrti3.c
  moddi3.c
  modsi3.c
  modti3.c
  muldc3.c
  muldf3.c
  muldi3.c
  mulodi4.c
  mulosi4.c
  muloti4.c
  mulsc3.c
  mulsf3.c
  multi3.c
  multf3.c
  mulvdi3.c
  mulvsi3.c
  mulvti3.c
  mulxc3.c
  negdf2.c
  negdi2.c
  negsf2.c
  negti2.c
  negvdi2.c
  negvsi2.c
  negvti2.c
  paritydi2.c
  paritysi2.c
  parityti2.c
  popcountdi2.c
  popcountsi2.c
  popcountti2.c
  powidf2.c
  powisf2.c
  powitf2.c
  powixf2.c
  subdf3.c
  subsf3.c
  subvdi3.c
  subvsi3.c
  subvti3.c
  subtf3.c
  trampoline_setup.c
  truncdfhf2.c
  truncdfsf2.c
  truncsfhf2.c
  ucmpdi2.c
  ucmpti2.c
  udivdi3.c
  udivmoddi4.c
  udivmodsi4.c
  udivmodti4.c
  udivsi3.c
  udivti3.c
  umoddi3.c
  umodsi3.c
  umodti3.c)

if(APPLE)
  set(GENERIC_SOURCES
    ${GENERIC_SOURCES}
    atomic_flag_clear.c
    atomic_flag_clear_explicit.c
    atomic_flag_test_and_set.c
    atomic_flag_test_and_set_explicit.c
    atomic_signal_fence.c
    atomic_thread_fence.c)
endif()

if(NOT WIN32)
  set(GENERIC_SOURCES
      ${GENERIC_SOURCES}
      emutls.c)
endif()

if (HAVE_UNWIND_H)
  set(GENERIC_SOURCES
      ${GENERIC_SOURCES}
      gcc_personality_v0.c)
endif ()

if (NOT MSVC)
  set(x86_64_SOURCES
      x86_64/floatdidf.c
      x86_64/floatdisf.c
      x86_64/floatdixf.c
      x86_64/floatundidf.S
      x86_64/floatundisf.S
      x86_64/floatundixf.S
      ${GENERIC_SOURCES})
  set(x86_64h_SOURCES ${x86_64_SOURCES})

  if (WIN32)
    set(x86_64_SOURCES
        ${x86_64_SOURCES}
        x86_64/chkstk.S
        x86_64/chkstk2.S)
  endif()

  set(i386_SOURCES
      i386/ashldi3.S
      i386/ashrdi3.S
      i386/divdi3.S
      i386/floatdidf.S
      i386/floatdisf.S
      i386/floatdixf.S
      i386/floatundidf.S
      i386/floatundisf.S
      i386/floatundixf.S
      i386/lshrdi3.S
      i386/moddi3.S
      i386/muldi3.S
      i386/udivdi3.S
      i386/umoddi3.S
      ${GENERIC_SOURCES})

  if (WIN32)
    set(i386_SOURCES
        ${i386_SOURCES}
        i386/chkstk.S
        i386/chkstk2.S)
  endif()

  set(i686_SOURCES
      ${i386_SOURCES})
else () # MSVC
  # Use C versions of functions when building on MSVC
  # MSVC's assembler takes Intel syntax, not AT&T syntax
  set(x86_64_SOURCES
      x86_64/floatdidf.c
      x86_64/floatdisf.c
      x86_64/floatdixf.c
      ${GENERIC_SOURCES})
  set(x86_64h_SOURCES ${x86_64_SOURCES})
  set(i386_SOURCES ${GENERIC_SOURCES})
  set(i686_SOURCES ${i386_SOURCES})
endif () # if (NOT MSVC)

set(arm_SOURCES
  arm/aeabi_cdcmp.S
  arm/aeabi_cdcmpeq_check_nan.c
  arm/aeabi_cfcmp.S
  arm/aeabi_cfcmpeq_check_nan.c
  arm/aeabi_dcmp.S
  arm/aeabi_div0.c
  arm/aeabi_drsub.c
  arm/aeabi_fcmp.S
  arm/aeabi_frsub.c
  arm/aeabi_idivmod.S
  arm/aeabi_ldivmod.S
  arm/aeabi_memcmp.S
  arm/aeabi_memcpy.S
  arm/aeabi_memmove.S
  arm/aeabi_memset.S
  arm/aeabi_uidivmod.S
  arm/aeabi_uldivmod.S
  arm/bswapdi2.S
  arm/bswapsi2.S
  arm/comparesf2.S
  arm/divmodsi4.S
  arm/divsi3.S
  arm/modsi3.S
  arm/negdf2vfp.S
  arm/negsf2vfp.S
  arm/switch16.S
  arm/switch32.S
  arm/switch8.S
  arm/switchu8.S
  arm/sync_fetch_and_add_4.S
  arm/sync_fetch_and_add_8.S
  arm/sync_fetch_and_and_4.S
  arm/sync_fetch_and_and_8.S
  arm/sync_fetch_and_max_4.S
  arm/sync_fetch_and_max_8.S
  arm/sync_fetch_and_min_4.S
  arm/sync_fetch_and_min_8.S
  arm/sync_fetch_and_nand_4.S
  arm/sync_fetch_and_nand_8.S
  arm/sync_fetch_and_or_4.S
  arm/sync_fetch_and_or_8.S
  arm/sync_fetch_and_sub_4.S
  arm/sync_fetch_and_sub_8.S
  arm/sync_fetch_and_umax_4.S
  arm/sync_fetch_and_umax_8.S
  arm/sync_fetch_and_umin_4.S
  arm/sync_fetch_and_umin_8.S
  arm/sync_fetch_and_xor_4.S
  arm/sync_fetch_and_xor_8.S
  arm/sync_synchronize.S
  arm/udivmodsi4.S
  arm/udivsi3.S
  arm/umodsi3.S
  ${GENERIC_SOURCES})

set(aarch64_SOURCES
  comparetf2.c
  extenddftf2.c
  extendsftf2.c
  fixtfdi.c
  fixtfsi.c
  fixtfti.c
  fixunstfdi.c
  fixunstfsi.c
  fixunstfti.c
  floatditf.c
  floatsitf.c
  floatunditf.c
  floatunsitf.c
  multc3.c
  trunctfdf2.c
  trunctfsf2.c
  ${GENERIC_SOURCES})

set(armhf_SOURCES
  arm/adddf3vfp.S
  arm/addsf3vfp.S
  arm/divdf3vfp.S
  arm/divsf3vfp.S
  arm/eqdf2vfp.S
  arm/eqsf2vfp.S
  arm/extendsfdf2vfp.S
  arm/fixdfsivfp.S
  arm/fixsfsivfp.S
  arm/fixunsdfsivfp.S
  arm/fixunssfsivfp.S
  arm/floatsidfvfp.S
  arm/floatsisfvfp.S
  arm/floatunssidfvfp.S
  arm/floatunssisfvfp.S
  arm/gedf2vfp.S
  arm/gesf2vfp.S
  arm/gtdf2vfp.S
  arm/gtsf2vfp.S
  arm/ledf2vfp.S
  arm/lesf2vfp.S
  arm/ltdf2vfp.S
  arm/ltsf2vfp.S
  arm/muldf3vfp.S
  arm/mulsf3vfp.S
  arm/nedf2vfp.S
  arm/nesf2vfp.S
  arm/restore_vfp_d8_d15_regs.S
  arm/save_vfp_d8_d15_regs.S
  arm/subdf3vfp.S
  arm/subsf3vfp.S
  arm/truncdfsf2vfp.S
  arm/unorddf2vfp.S
  arm/unordsf2vfp.S
  ${arm_SOURCES})
set(armv7_SOURCES ${arm_SOURCES})
set(armv7s_SOURCES ${arm_SOURCES})
set(arm64_SOURCES ${aarch64_SOURCES})

# macho_embedded archs
set(armv6m_SOURCES ${GENERIC_SOURCES})
set(armv7m_SOURCES ${arm_SOURCES})
set(armv7em_SOURCES ${arm_SOURCES})

set(mips_SOURCES ${GENERIC_SOURCES})
set(mipsel_SOURCES ${mips_SOURCES})
set(mips64_SOURCES ${mips_SOURCES})
set(mips64el_SOURCES ${mips_SOURCES})

add_custom_target(builtins)

if (APPLE)
  add_subdirectory(Darwin-excludes)
  add_subdirectory(macho_embedded)
  darwin_add_builtin_libraries(${BUILTIN_SUPPORTED_OS})
else ()
  foreach (arch ${BUILTIN_SUPPORTED_ARCH})
    if (CAN_TARGET_${arch})
      # Filter out generic versions of routines that are re-implemented in
      # architecture specific manner.  This prevents multiple definitions of the
      # same symbols, making the symbol selection non-deterministic.
      foreach (_file ${${arch}_SOURCES})
        if (${_file} MATCHES ${arch}/*)
          get_filename_component(_name ${_file} NAME)
          string(REPLACE ".S" ".c" _cname "${_name}")
          list(REMOVE_ITEM ${arch}_SOURCES ${_cname})
        endif ()
      endforeach ()

      # Rust: don't insert a reference to MSVCRT.lib/etc
      if (MSVC)
        set(_cflags -Zl)
      else ()
        set(_cflags -std=c99)
      endif ()

      add_compiler_rt_runtime(clang_rt.builtins
                              STATIC
                              ARCHS ${arch}
                              SOURCES ${${arch}_SOURCES}
                              CFLAGS ${_cflags}
                              PARENT_TARGET builtins)
    endif ()
  endforeach ()
endif ()

add_dependencies(compiler-rt builtins)

=== src/test/run-make/dep-info-no-analysis/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) -o $(TMPDIR)/input.dd -Z no-analysis --emit dep-info input.rs
	sed -i'.bak' 's/^.*input.dd/input.dd/g' $(TMPDIR)/input.dd
	diff -u $(TMPDIR)/input.dd input.dd

=== debian/changelog ===
rustc (1.10.0+dfsg1-3) unstable; urgency=medium

  * Rebuild with LLVM 3.8, same as what upstream are using
  * Dynamically link against LLVM. (Closes: #832565)

 -- Ximin Luo <infinity0@debian.org>  Sat, 30 Jul 2016 22:36:41 +0200

rustc (1.10.0+dfsg1-2) unstable; urgency=medium

  * Tentatively support ARM architectures
  * Include upstream arm64,armel,armhf stage0 compilers (i.e. 1.9.0 stable)
    in a orig-dl tarball, like how we previously did for amd64,i386.

 -- Ximin Luo <infinity0@debian.org>  Fri, 22 Jul 2016 15:54:51 +0200

rustc (1.10.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Add myself to uploaders
  * Update our build process to bootstrap from the previous Debian rustc stable
    version by default. See README.Debian for other options.
  * Update to latest Standards-Version; no changes required.

 -- Ximin Luo <infinity0@debian.org>  Sun, 17 Jul 2016 03:40:49 +0200

=== debian/control ===
Source: rustc
Section: devel
Priority: extra
Maintainer: Rust Maintainers <pkg-rust-maintainers@lists.alioth.debian.org>
Uploaders: Jordan Justen <jordan.l.justen@intel.com>,
 Luca Bruno <lucab@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>,
 Angus Lees <gus@debian.org>,
 Ximin Luo <infinity0@debian.org>
Build-Depends: debhelper (>= 9.20141010),
               dpkg-dev (>= 1.17.14),
               rustc (>= 1.9.0+dfsg) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
               rustc (<= 1.10.0++) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
               autotools-dev,
               binutils-multiarch,
               curl,
               python,
               nodejs,
               zlib1g-dev,
               libedit-dev,
               valgrind,
               git,
               procps,
               cmake,
# git, procps are necessary for 'make check'
               antlr4,
               bison,
               flex,
               gdb,
               default-jdk,
# above are optional tools for 'make check'
               llvm-3.8-dev,
               llvm-3.8-tools
Build-Depends-Indep: pandoc (>= 1.9),
                     po4a,
                     texlive-xetex,
                     texlive-latex-base,
                     texlive-generic-recommended,
                     texlive-fonts-recommended,
                     lmodern
Standards-Version: 3.9.8
Homepage: http://www.rust-lang.org/
Vcs-Git: https://anonscm.debian.org/git/pkg-rust/rust.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git

Package: rustc
Architecture: amd64 arm64 armel armhf i386
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
 gcc, libc-dev
Recommends: rust-gdb | rust-lldb
Suggests: rust-doc
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-1.10
Section: libs
Architecture: amd64 arm64 armel armhf i386
Multi-Arch: same
Pre-Depends: multiarch-support, ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs.

Package: libstd-rust-dev
Section: libdevel
Architecture: amd64 arm64 armel armhf i386
Multi-Arch: same
Pre-Depends: multiarch-support
Depends: ${misc:Depends}, libstd-rust-1.10 (= ${binary:Version})
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files necessary to use the standard
 Rust libraries.

Package: rust-gdb
Architecture: any
Depends: gdb, ${misc:Depends}
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-lldb
Architecture: any
Depends: lldb, ${misc:Depends}
Replaces: rustc (<< 1.1.0+dfsg1-1)
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends}, libjs-jquery
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
#RUSTFLAGS = -C link-args="$(LDFLAGS)"
# temporary workaround for https://github.com/rust-lang/rust/issues/31529
# this will FAIL if LDFLAGS itself contains shell-interpreted chars beyond
# unquoted spaces (that addprefix works around the failure of)
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# When using sudo pbuilder, this will cause mk/install.mk to run sudo,
# but we don't need sudo as a build-dep for the package if we unexport
# the SUDO_USER variable.
unexport SUDO_USER

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Debhelper clears MAKEFLAGS, so we have to do this again for any
# target where we call $(MAKE) directly.  Boo.
DEB_PARALLEL_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PMAKE = $(MAKE) $(if $(DEB_PARALLEL_JOBS),-j$(DEB_PARALLEL_JOBS))

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUST_VERSION := $(shell dpkg-parsechangelog --show-field Version | sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)

# These are the normal build flags
DEB_CONFIGURE_FLAGS = \
               --host=$(DEB_HOST_RUST_TYPE) \
               --target=$(DEB_TARGET_RUST_TYPE) \
               --disable-manage-submodules \
               --release-channel=$(RELEASE_CHANNEL) \
               --prefix=/usr

# Use system LLVM (comment out to use vendored LLVM)
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-3.8

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := /^Build-Depends:/,/^[^[:space:]\#]/{/\s*rustc.*,/$$action}
PRECONFIGURE_CHECK = :
ifeq (0,$(shell ls -1 dl/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into dl/ and use that.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-dl` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control))
    ifeq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for dl/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif


%:
	dh $@ --parallel

# Note: SHELL is not set by dash, but the configure script wants to use it
override_dh_auto_configure:
	$(PRECONFIGURE_CHECK)
	SHELL=/bin/sh PATH="$$PWD/debian/bin:$$PATH" DEB_HOST_ARCH="$(DEB_HOST_ARCH)" \
	    ./configure $(DEB_CONFIGURE_FLAGS)

override_dh_auto_clean:
	set -e; \
	if [ -f Makefile ]; then \
	  $(PMAKE) clean-all; \
	  $(RM) Makefile config.stamp config.mk; \
	fi
	$(RM) src/bootstrap/bootstrap.pyc

override_dh_auto_build-arch:
	dh_auto_build -- all VERBOSE=1

override_dh_auto_build-indep:
	$(if $(BUILD_DOCS),dh_auto_build -- docs)

override_dh_auto_install:
	dh_auto_install --destdir=$(DEB_DESTDIR)

	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(DEB_DESTDIR)/usr/lib/lib*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Replace duplicated compile-time/run-time dylibs with symlinks
	@set -e; \
	for f in $(DEB_DESTDIR)/usr/lib/rustlib/$(DEB_HOST_RUST_TYPE)/lib/lib*.so; do \
	  name=$${f##*/}; \
	  if [ -f "$(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/$$name" ]; then \
	    echo "ln -sf ../../../$(DEB_HOST_MULTIARCH)/$$name $$f"; \
	    ln -sf ../../../$(DEB_HOST_MULTIARCH)/$$name $$f; \
	  fi; \
	done

ifneq (,$(BUILD_DOCS))
	# Brute force to remove privacy-breach-logo lintian warning.
	# We could have updated the upstream sources but it would complexify
	# the rebase
	@set -e; \
	find $(DEB_DESTDIR)/usr/share/doc/rust/html -iname '*.html' | \
	while read file; do \
	  topdir=$$(echo "$$file" | sed 's,^$(DEB_DESTDIR)/usr/share/doc/rust/html/,,; s,/[^/]*$$,/,; s,^[^/]*$$,,; s,[^/]\+/,../,g'); \
	  sed -i -e "s,https://doc.rust-lang.org/\(favicon.ico\|logos/rust-logo-32x32-blk.png\),$${topdir}rust-logo-32x32-blk.png," \
              -e "s,https://www.rust-lang.org/\(favicon.ico\|logos/rust-logo-32x32-blk.png\),$${topdir}rust-logo-32x32-blk.png," "$$file"; \
	done

	find $(DEB_DESTDIR) \( -iname '*.html' -empty -o -name .lock -o -name '*.inc' \) -delete
endif

override_dh_install-arch:
	dh_install
	dh_install -p$(LIBSTD_PKG) usr/lib/$(DEB_HOST_MULTIARCH)/

	chmod -x \
	  debian/rust-gdb/usr/share/rust-gdb/*.py \
	  debian/rust-lldb/usr/share/rust-lldb/*.py

override_dh_installchangelogs:
	dh_installchangelogs RELEASES.md

override_dh_installdocs:
	dh_installdocs -X.tex -X.aux -X.log -X.out -X.toc

override_dh_compress:
	dh_compress -X.woff

override_dh_auto_test:
ifeq (, $(filter nocheck,$(DEB_BUILD_OPTIONS)))
	RUST_BACKTRACE=1 $(PMAKE) VERBOSE=1 check-notidy
endif

override_dh_makeshlibs:
	dh_makeshlibs -V

	# dh_makeshlibs doesn't support our "libfoo-version.so" naming
	# structure, so we have to do this ourselves.
	install -o 0 -g 0 -d debian/$(LIBSTD_PKG)/DEBIAN
	LC_ALL=C ls debian/$(LIBSTD_PKG)/usr/lib/$(DEB_HOST_MULTIARCH)/lib*.so | \
	sed -n 's,^.*/\(lib.*\)-\(.\+\)\.so$$,\1 \2,p' | \
	while read name version; do \
	  echo "$$name $$version $(LIBSTD_PKG) (>= $(DEB_VERSION_UPSTREAM))"; \
	done > debian/$(LIBSTD_PKG)/DEBIAN/shlibs
	chmod 644 debian/$(LIBSTD_PKG)/DEBIAN/shlibs
	chown 0:0 debian/$(LIBSTD_PKG)/DEBIAN/shlibs

override_dh_shlibdeps:
	dh_shlibdeps -- -x$(LIBSTD_PKG)

QUILT_SPECIAL_SNOWFLAKE_RETURN_CODE = x=$$?; if [ $$x = 2 ]; then exit 0; else exit $$x; fi
source_orig-dl:
	QUILT_PATCHES=debian/patches quilt push -aq; $(QUILT_SPECIAL_SNOWFLAKE_RETURN_CODE)
	$(MAKE) -f debian/rules clean
	debian/make_orig-dl_tarball.sh
	QUILT_PATCHES=debian/patches quilt pop -aq; $(QUILT_SPECIAL_SNOWFLAKE_RETURN_CODE)
	rm -rf .pc

=== debian/watch ===
version=3

opts="\
pgpsigurlmangle=s/$/.asc/,\
uversionmangle=s/(\d)[_.+-]?((beta|alpha)\.?\d*)$/$1~$2/,\
dversionmangle=s/\+dfsg\d*$//,\
repack,\
repacksuffix=+dfsg1,\
compression=xz,\
" \
 https://www.rust-lang.org/downloads.html \
 (?:.*/)rustc?-(\d[\d.]*(?:-[\w.]+)?)-src\.tar\.gz

## rustc 1.15.1+dfsg0

=== src/test/run-make/rustc-macro-dep-files/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) foo.rs
	$(RUSTC) bar.rs --emit dep-info
	grep "proc-macro source" $(TMPDIR)/bar.d && exit 1 || exit 0

=== src/test/run-make/stable-symbol-names/Makefile ===
-include ../tools.mk

# The following command will:
#  1. dump the symbols of a library using `nm`
#  2. extract only those lines that we are interested in via `grep`
#  3. from those lines, extract just the symbol name via `sed`
#     (symbol names always start with "_ZN" and end with "E")
#  4. sort those symbol names for deterministic comparison
#  5. write the result into a file

dump-symbols = nm "$(TMPDIR)/lib$(1).rlib" \
             | grep -E "some_test_function|Bar|bar" \
             | sed "s/.*\(_ZN.*E\).*/\1/" \
             | sort \
             > "$(TMPDIR)/$(1).nm"

all:
	$(RUSTC) stable-symbol-names1.rs
	$(RUSTC) stable-symbol-names2.rs
	$(call dump-symbols,stable_symbol_names1)
	$(call dump-symbols,stable_symbol_names2)
	cmp "$(TMPDIR)/stable_symbol_names1.nm" "$(TMPDIR)/stable_symbol_names2.nm"

=== debian/changelog ===
rustc (1.15.1+dfsg0-1~exp1ubuntu2~16.10.1) yakkety-security; urgency=medium

  * Rebuild using the rustc binaries in the PPA

 -- Chris Coulson <chris.coulson@canonical.com>  Wed, 01 Mar 2017 08:36:25 +0000

rustc (1.15.1+dfsg0-1~exp1ubuntu1~16.10~1) yakkety; urgency=medium

  * SRU: LP: #1667662. Build for 16.04 LTS.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 27 Feb 2017 09:47:27 +0100

rustc (1.15.1+dfsg0-1~exp1ubuntu2) zesty; urgency=medium

  * Build on all architectures.
  * Disable validation of binary tarballs.
  * Work around a GCC 4.8 ICE on AArch64.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 26 Feb 2017 11:11:49 +0100

rustc (1.15.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release (won't probably be in stretch).
    see the 1.4 git branch for the follow up for stable 
  * d/p/patches/disable-doc-build-in-all.diff:
    all-no-docs no longer exists. Disable the call to doc in all
  * Call to the test renamed from check-notidy => check
  * d/p/disable-check-tool-tidy.diff:
    Disable the call to check-tidy
  * Refresh of the patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 03 Feb 2017 15:34:42 +0100

rustc (1.14.0+dfsg1-3ubuntu1) zesty; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Unconditionally build-depend on rustc.
    - Always build using the rustc from the archive.
    - Ignore the test results.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 12 Jan 2017 09:29:09 +0100

rustc (1.14.0+dfsg1-3) unstable; urgency=medium

  * Fix mips64 Makefile patches.
  * Don't run arch-dep tests in a arch-indep build.

 -- Ximin Luo <infinity0@debian.org>  Wed, 04 Jan 2017 21:34:56 +0100

rustc (1.14.0+dfsg1-2) unstable; urgency=medium

  * Update README.Debian, the old one was way out of date.
  * Detect mips CPUs in ./configure and fill in mips Makefile rules.
  * Work around jemalloc-related problems in the upstream bootstrapping
    binaries for arm64, ppc64el, s390x.
  * Disable jemalloc on s390x - upstream already disable it for some other
    arches.
  * Disable jemalloc tests for arches where jemalloc is disabled.
  * We still expect the following failures:
    * arm64 should be fixed (i.e. no failures) compared to the previous upload.
    * armhf will FTBFS due to 'Illegal instruction' and this can only be fixed
      with the next stable rustc release.
    * mips mipsel mips64el ppc64 ppc64el s390x will FTBFS due to yet other
      test failures beyond the ones I fixed above; this upload is only to save
      me manual work in producing nice reports that exhibit these failures.

 -- Ximin Luo <infinity0@debian.org>  Thu, 29 Dec 2016 23:00:47 +0100

rustc (1.14.0+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release
  * Update debian/watch

  [ Ximin Luo ]
  * Try to bootstrap armhf ppc64 ppc64el s390x mips mipsel mips64el.
    (Closes: #809316, #834003, #839643)
  * Make rust-gdb and rust-lldb arch:all packages.
  * Switch to debhelper 10.

 -- Ximin Luo <infinity0@debian.org>  Sat, 24 Dec 2016 18:03:03 +0100

rustc (1.13.0+dfsg1-2) unstable; urgency=high

  * Skip macro-stepping test on arm64, until
    https://github.com/rust-lang/rust/issues/37225 is resolved.

 -- Luca Bruno <lucab@debian.org>  Sat, 26 Nov 2016 23:40:14 +0000

rustc (1.13.0+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New upstream release.

  [ Ximin Luo ]
  * Use Debian system jquery instead of upstream's embedded copy.

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 11 Nov 2016 13:35:23 +0100

rustc (1.12.1+dfsg1-1) unstable; urgency=medium

  [ Sylvestre Ledru ]
  * New (minor) upstream release
  * Missing dependency from rust-lldb to python-lldb-3.8 (Closes: #841833)
  * Switch to llvm 3.9. (Closes: #841834)

  [ Ximin Luo ]
  * Dynamically apply rust-boot-1.12.1-from-1.12.0.diff.
    This allows us to bootstrap from either 1.11.0 or 1.12.0.
  * Bump LLVM Build-Depends version to get the backported patches for LLVM
    #30402 and #29163.
  * Install debugger_pretty_printers_common to rust-gdb and rust-lldb.
    (Closes: #841835)

 -- Ximin Luo <infinity0@debian.org>  Mon, 07 Nov 2016 14:15:14 +0100

rustc (1.12.0+dfsg1-2) unstable; urgency=medium

  * Ignore test run-make/no-duplicate-libs. Fails on i386
  * Ignore test run-pass-valgrind/down-with-thread-dtors.rs . Fails on arm64
  * I am not switching to llvm 3.9 now because a test freezes. The plan is
    to silent the warning breaking the build and upload 1.12.1 after

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 05 Oct 2016 10:48:01 +0200

rustc (1.12.0+dfsg1-1) unstable; urgency=medium

  * new upstream release
    - Rebase of the patches and removal of deprecated patches

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 29 Sep 2016 20:45:04 +0200

rustc (1.11.0+dfsg1-3) unstable; urgency=medium

  * Fix separate build-arch and build-indep builds.

 -- Ximin Luo <infinity0@debian.org>  Tue, 13 Sep 2016 12:30:41 +0200

rustc (1.11.0+dfsg1-2) unstable; urgency=medium

  * Fix rebuilding against the current version, by backporting a patch I wrote
    that was already applied upstream. Should fix the FTBFS that was observed
    by tests.reproducible-builds.org.
  * Ignore a failing stdcall test on arm64; should fix the FTBFS there.
  * Backport a doctest fix I wrote, already applied upstream.

 -- Ximin Luo <infinity0@debian.org>  Mon, 12 Sep 2016 17:40:12 +0200

rustc (1.11.0+dfsg1-1) unstable; urgency=medium

  * New upstream release
  * Add versioned binutils dependency. (Closes: #819475, #823540)

 -- Ximin Luo <infinity0@debian.org>  Wed, 07 Sep 2016 10:31:57 +0200

=== debian/control ===
--- 
+++ 
@@ -7,31 +7,35 @@
  Sylvestre Ledru <sylvestre@debian.org>,
  Angus Lees <gus@debian.org>,
  Ximin Luo <infinity0@debian.org>
-Build-Depends: debhelper (>= 9.20141010),
-               dpkg-dev (>= 1.17.14),
-               rustc (>= 1.9.0+dfsg) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
-               rustc (<= 1.10.0++) [!arm64 !armel !armhf] <!pkg.rustc.dlstage0>,
+Build-Depends: debhelper (>= 9),
+               rustc (>= 1.14.0+dfsg) [!powerpc],
+               rustc (<= 1.15.1++) [!powerpc],
                autotools-dev,
-               binutils-multiarch,
+               binutils,
+               cmake,
                curl,
+               gperf,
+               libedit-dev,
+               llvm-3.9-dev (>= 1:3.9-5),
+               llvm-3.9-tools (>= 1:3.9-5),
                python,
-               nodejs,
                zlib1g-dev,
-               libedit-dev,
-               valgrind,
-               git,
-               procps,
-               cmake,
-# git, procps are necessary for 'make check'
-               antlr4,
-               bison,
-               flex,
-               gdb,
-               default-jdk,
-# above are optional tools for 'make check'
-               llvm-3.8-dev,
-               llvm-3.8-tools
-Build-Depends-Indep: pandoc (>= 1.9),
+               nodejs <!nocheck>,
+               valgrind <!nocheck>,
+               git <!nocheck>,
+               procps <!nocheck>,
+# the tests require the docs to be built, which requires jquery
+               libjs-jquery <!nocheck>,
+# below are optional tools even for 'make check'
+               antlr4 <!nocheck>,
+               bison <!nocheck>,
+               flex <!nocheck>,
+# temporarily disabled because of https://github.com/rust-lang/rust/issues/36323
+# we should be able to re-enable it soon, it seems already fixed in rustc head + gdb trunk
+#               gdb <!nocheck>,
+               default-jdk-headless <!nocheck>,
+Build-Depends-Indep: libjs-jquery <!nodoc>,
+                     pandoc (>= 1.9),
                      po4a,
                      texlive-xetex,
                      texlive-latex-base,
@@ -44,11 +48,11 @@
 Vcs-Browser: https://anonscm.debian.org/cgit/pkg-rust/rust.git
 
 Package: rustc
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: foreign
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}, libstd-rust-dev (= ${binary:Version}),
- gcc, libc-dev
+ gcc, libc-dev, libjs-jquery, binutils (>= 2.26)
 Recommends: rust-gdb | rust-lldb
 Suggests: rust-doc
 Description: Rust systems programming language
@@ -64,9 +68,9 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-1.10
+Package: libstd-rust-1.15
 Section: libs
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: same
 Pre-Depends: multiarch-support, ${misc:Pre-Depends}
 Depends: ${shlibs:Depends}, ${misc:Depends}
@@ -87,10 +91,10 @@
 
 Package: libstd-rust-dev
 Section: libdevel
-Architecture: amd64 arm64 armel armhf i386
+Architecture: any
 Multi-Arch: same
 Pre-Depends: multiarch-support
-Depends: ${misc:Depends}, libstd-rust-1.10 (= ${binary:Version})
+Depends: ${misc:Depends}, libstd-rust-1.15 (= ${binary:Version})
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -108,7 +112,7 @@
  Rust libraries.
 
 Package: rust-gdb
-Architecture: any
+Architecture: all
 Depends: gdb, ${misc:Depends}
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (gdb)
@@ -128,8 +132,8 @@
  invoking gdb on rust binaries.
 
 Package: rust-lldb
-Architecture: any
-Depends: lldb, ${misc:Depends}
+Architecture: all
+Depends: lldb-3.9, ${misc:Depends}, python-lldb-3.9
 Replaces: rustc (<< 1.1.0+dfsg1-1)
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/buildflags.mk
#RUSTFLAGS = -C link-args="$(LDFLAGS)"
# temporary workaround for https://github.com/rust-lang/rust/issues/31529
# this will FAIL if LDFLAGS itself contains shell-interpreted chars beyond
# unquoted spaces (that addprefix works around the failure of)
RUSTFLAGS = $(addprefix -C link-args=,$(LDFLAGS))
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS RUSTFLAGS

# see https://github.com/rust-lang/rust/issues/37320
# it should be possible to remove this in the next Debian release
export MALLOC_CONF = lg_dirty_mult:-1

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# When using sudo pbuilder, this will cause mk/install.mk to run sudo,
# but we don't need sudo as a build-dep for the package if we unexport
# the SUDO_USER variable.
unexport SUDO_USER

# src/rt/miniz.c (incorrectly) triggers -Wmisleading-indentation with
# gcc-6.  See bug #811573.
CFLAGS += -Wno-misleading-indentation

# Debhelper clears MAKEFLAGS, so we have to do this again for any
# target where we call $(MAKE) directly.  Boo.
DEB_PARALLEL_JOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
PMAKE = $(MAKE) $(if $(DEB_PARALLEL_JOBS),-j$(DEB_PARALLEL_JOBS))

# Release type (one of beta, stable or nightly)
RELEASE_CHANNEL := stable
# See also ./build-preview-dsc.sh for a script that builds a beta/nightly .dsc
# out of this packaging. Furthermore, if the build breaks after importing a new
# upstream stable release, check the do_temporary_fixup function in that file
# to see if we already know what fix to make.

DEB_DESTDIR := $(CURDIR)/debian/tmp

RUST_VERSION := $(shell dpkg-parsechangelog --show-field Version | sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/')
LIBSTD_PKG := libstd-rust-$(RUST_VERSION)

# These are the normal build flags
DEB_CONFIGURE_FLAGS = \
               --host=$(DEB_HOST_RUST_TYPE) \
               --target=$(DEB_TARGET_RUST_TYPE) \
               --disable-manage-submodules \
               --disable-rustbuild \
               --release-channel=$(RELEASE_CHANNEL) \
               --prefix=/usr

# Use system LLVM (comment out to use vendored LLVM)
OLD_LLVM_VERSION = 3.8
DEB_CONFIGURE_FLAGS += --llvm-root=/usr/lib/llvm-3.9

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
# Sed expression that matches the "rustc" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := /^Build-Depends:/,/^[^[:space:]\#]/{/\s*rustc.*,/$$action}
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 dl/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
# allow not using the binary tarball although it exists
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 ppc64el s390x))
  HAVE_BINARY_TARBALL := 0
endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        DEB_CONFIGURE_FLAGS += --enable-local-rust --local-rust-root=/usr
    endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into dl/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-dl` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control))
    ifeq (,$(shell action=p; sed -ne "$(SED_RUSTC_BUILDDEP)" debian/control | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for dl/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS = 1
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  DEB_CONFIGURE_FLAGS += --disable-docs
  BUILD_DOCS =
endif

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  DEB_CONFIGURE_FLAGS += --disable-optimize --disable-optimize-cxx --disable-optimize-llvm
endif


%:
	dh $@ --parallel

# Note: SHELL is not set by dash, but the configure script wants to use it
override_dh_auto_configure:
	ld --version

	: # FIXME: These should be part of the -dl tarball ...
	echo 'e800622715e1122263ece76ab30b0d6be300b992f241de945438623c39b475eb  rustc-1.14.0-aarch64-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-aarch64-unknown-linux-gnu.tar.gz.sha256
	echo 'dc2c5dd293971cf82aaa34b1b1c0823de76ebbc8df10a9fe527455862e1db62f  rustc-1.14.0-arm-unknown-linux-gnueabi.tar.gz' \
	  > dl/rustc-1.14.0-arm-unknown-linux-gnueabi.tar.gz.sha256
	echo '12d91c29e0bfc47168bf801a19153e91dbe6fac37dd47884a8268ba7477ef3ea  rustc-1.14.0-armv7-unknown-linux-gnueabihf.tar.gz' \
	  > dl/rustc-1.14.0-armv7-unknown-linux-gnueabihf.tar.gz.sha256
	echo 'af22508823865245dc1c451d79679c33898092573608017b5b4b764b1dfe205e  rustc-1.14.0-i686-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-i686-unknown-linux-gnu.tar.gz.sha256
	echo 'f01fa663b1f8290c1d8f3542b6c7376f2188a63aa6b3eccde3c46479a405597d  rustc-1.14.0-powerpc-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-powerpc-unknown-linux-gnu.tar.gz.sha256
	echo '1a7710324bd6508aa04d6a279e38ed8e8ea096edb2aceb600cf1843f8d161af3  rustc-1.14.0-powerpc64le-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-powerpc64le-unknown-linux-gnu.tar.gz.sha256
	echo '5b3f57fd2e09630724c12ecce10761439700a7b6838cdefe9e474b3d5640a083  rustc-1.14.0-s390x-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-s390x-unknown-linux-gnu.tar.gz.sha256
	echo '3df0ba1f65366e9220788b13ff0b91a2c3e46bfde196d54b233038157d040a9e  rustc-1.14.0-x86_64-unknown-linux-gnu.tar.gz' \
	  > dl/rustc-1.14.0-x86_64-unknown-linux-gnu.tar.gz.sha256

	# fail the build if we have any instances of OLD_LLVM_VERSION in debian, except for debian/changelog
	! grep --color=always -i 'll...$(OLD_LLVM_VERSION)' --exclude=changelog -R debian
	$(PRECONFIGURE_CHECK)
	SHELL=/bin/sh PATH="$$PWD/debian/bin:$$PATH" DEB_HOST_ARCH="$(DEB_HOST_ARCH)" \
	    ./configure $(DEB_CONFIGURE_FLAGS)

override_dh_auto_clean:
	set -e; \
	if [ -f Makefile ]; then \
	  $(MAKE) clean-all; \
	  $(RM) Makefile config.stamp config.mk; \
	fi
	$(RM) src/rt/hoedown/src/html_blocks.c # clean up after building this ourselves
	$(RM) src/bootstrap/bootstrap.pyc
	$(RM) dl/*.sha256

# upstream bundles this in the source, but in Debian we rebuild everything yo
generate-sources:
	$(MAKE) -C src/rt/hoedown src/html_blocks.c

override_dh_auto_build-arch: generate-sources
	dh_auto_build -- all VERBOSE=1

# note: this is only for buildds that want to do a separate arch:all build;
# there is no point running this yourself "to save time" since it implicitly
# depends on build-arch anyways.
override_dh_auto_build-indep: generate-sources
ifneq (,$(BUILD_DOCS))
	dh_auto_build -- docs VERBOSE=1
endif

override_dh_auto_install:
	dh_auto_install --destdir=$(DEB_DESTDIR)

	mkdir -p $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv $(DEB_DESTDIR)/usr/lib/lib*.so $(DEB_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH)/

	# Replace duplicated compile-time/run-time dylibs with symlinks
	@set -e; \
